<template>
  <div>
    <table class="table table-dark table-striped">
      <thead class="text-center">
        <tr>
          <th>Usuario</th>
          <th>Questões</th>
          <th>Editar</th>
          <th>Deletar</th>
        </tr>
      </thead>
      <tbody class="text-center" v-for="dados in quest" :key="dados.IdQ">
        <tr>
          <td>{{ dados.usuario }}</td>
          <td>{{ dados.questao }}</td>
          <td>
            <b-button
              @click="HandlerEditar(dados.idQ)"
              data-toggle="modal"
              data-target="#modalEditar"
              class="btn btn-info"
              ><b-icon icon="pencil-fill"></b-icon
            ></b-button>
          </td>
          <td>
            <b-button
              @click="HandlerExcluir(dados.idQ)"
              data-toggle="modal"
              data-target="#modalDeletar"
              class="btn btn-danger"
              ><b-icon icon="trash-fill"></b-icon
            ></b-button>
          </td>
        </tr>
      </tbody>
    </table>

    <!-- Modal Resposta -->
    <div>
      <!-- The Modal -->
      <div class="modal fade" id="modalEditar" role="dialog">
        <div class="modal-dialog">
          <div class="modal-content">
            <!-- Modal Header -->
            <div id="addcoment" class="modal-header">
              <h3>Edite Sua Questão</h3>
            </div>
            <div class="modal-body">
              <textarea
                class="form-control"
                rows="5"
                v-model="questaoEditada.questao"
                id="comment"
              ></textarea>
            </div>
            <!-- Modal footer -->
            <div class="modal-footer" id="bottonDeletar">
              <button
                type="button"
                class="btn-dark btn-sm mr-2"
                data-dismiss="modal"
              >
                <b-icon
                  icon="x"
                  scale="2"
                  variant="white"
                  class="mr-2"
                ></b-icon>
                Cancelar
              </button>
              <button
                @click.prevent="EditarQuest"
                class="btn btn-sm btn-info"
                type="submit"
                data-dismiss="modal"
              >
                <b-icon icon="pencil-fill" font-scale="1"></b-icon> Editar
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!--  -->
    <!-- Modal Excluir -->
    <div>
      <!-- The Modal -->
      <div class="modal fade" id="modalDeletar" role="dialog">
        <div class="modal-dialog">
          <div class="modal-content">
            <!-- Modal Header -->
            <div id="addcoment" class="modal-header">
              <h3>Deseja Deletar Esta Questão?</h3>
            </div>

            <!-- Modal footer -->
            <div class="modal-footer" id="bottonDeletar">
              <button
                type="button"
                class="btn-dark btn-sm mr-2"
                data-dismiss="modal"
              >
                <b-icon
                  icon="x"
                  scale="2"
                  variant="white"
                  class="mr-2"
                ></b-icon>
                Cancelar
              </button>
              <button
                @click.prevent="DeletarQuest"
                class="btn btn-sm btn-danger"
                type="submit"
                data-dismiss="modal"
              >
                <b-icon icon="trash-fill" font-scale="1"></b-icon> Deletar
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <!--  -->
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    return {
      quest: [],
      questaoEditada: {
        questao: null,
      },
    };
  },

  methods: {
    HandlerEditar(valor) {
      this.editQuest = valor;
    },

    EditarQuest() {
      if (localStorage.getItem("token")) {
        axios
          .put(`${this.$urlAPI}/quest/${this.editQuest}`, this.questaoEditada, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => {
            if (response.data.erro == "true") {
              alert(response.data.msg);
              window.location.reload();
            } else {
              alert(response.data.msg);
              window.location.reload();
            }
          });
      }
    },
    HandlerExcluir(valor) {
      this.deleteQuest = valor;
    },

    DeletarQuest() {
      if (localStorage.getItem("token")) {
        axios
          .delete(`${this.$urlAPI}/quest/${this.deleteQuest}`, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => {
            if (response.data.erro == "true") {
              alert(response.data.msg);
              window.location.reload();
            } else {
              alert(response.data.msg);
            }
          });
      }
    },
  },
  mounted() {
    if (localStorage.getItem("token")) {
      axios
        .get(`${this.$urlAPI}/quest/${localStorage.getItem("idU")}`, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => {
          if (response.data.erro == "false") {
            this.quest = response.data.dados;
          }
          if (response.data.erro == "true") {
            alert(response.data.msg);
          }
        });
    } else {
      this.$router.push("/login").catch(() => {});
    }
  },
};
</script>

<style scoped>
.td {
  margin-top: 15px;
}

#bottonDeletar {
  align-self: center;
}
</style>